---
title: Change Question Title Colors
product: PDF Generator
description: Learn how to add custom visual elements to your question titles in PDF forms. Our free demo for JavaScript will show you how to change the color of question titles to improve their visibility and enhance the overall appearance of your PDF forms.
framework: Vanilla JS
source: https://surveyjs.io/pdf-generator/examples/how-to-customize-question-title-colors-in-pdf-form/vanillajs
index: https://surveyjs.io/pdf-generator/examples/overview.md
---

# Change Question Title Colors (Vanilla JS)

This demo example shows how to change the color of question titles in a generated PDF form. This feature is especially useful for quiz and test results&mdash;you can visually indicate correctly and incorrectly answered questions using color. To generate a PDF form with applied customizations, answer the quiz questions and click the "Download PDF" or "Preview PDF" button.

## Customize Question Titles

To customize question title colors, handle the [`onGetQuestionStyle`](https://surveyjs.io/pdf-generator/documentation/api-reference/surveypdf#onGetQuestionStyle) event. Within the event handler, use the `options.style` configuration object to obtain and customize styles applied to an individual form field. To apply a custom color to a question title, modify the `options.style.title.fontColor` property. 

You can specify colors directly (for example, using hex values like `"#00ff00"` for green and `"#ff0000"` for red), or obtain them from the current survey theme if you prefer consistency with other styling. To obtain these colors, use the `options.getColorVariable` function.

## Customize Choice Options 

To modify the appearance of a choice's mark and label, handle the [`onGetItemStyle`](https://surveyjs.io/pdf-generator/documentation/api-reference/surveypdf#onGetItemStyle) event. Within the event handler, use the `options.style` configuration object to modify the appearance of a choice item.

Refer to the code listing for more information.

## Files

### `public/index.html`

```html
<div style="display: flex;">
    <div id="surveyElement" style="flex: 1 1 0%; height: 100%; min-width: 0;"></div>
    <div id="pdf-preview" style="flex: 0.7 0.7 0%; display: none">
        <embed id="pdf-preview-frame" type="application/pdf" style="width:100%; height:100%;" />
    </div>
</div>
```

### `src/index.css`

```css
/* You can add your custom CSS here. */
```

### `src/index.js`

```js
import { Model } from "survey-core";
import "survey-js-ui";
import { SurveyPDF } from "survey-pdf";
import "survey-core/survey-core.min.css";
import "./index.css";
import { json } from "./json";

function createSurveyPdfModel (surveyModel) {
    const surveyPDF = new SurveyPDF(json);
    if (surveyModel) {
        surveyPDF.data = surveyModel.data;
        surveyPDF.locale = surveyModel.locale;
        
        
    }
    surveyPDF.readOnly = true;
    surveyPDF.onGetQuestionStyle.add((_, options) => {  
        const question = options.question;
        const style = options.style;
        const correctColor = options.getColorVariable("--sjs2-color-fg-positive-primary");
        const incorrectColor = options.getColorVariable("--sjs2-color-fg-alert-primary");

        if (question.correctAnswer !== undefined && question.correctAnswer !== null) {
            const isCorrect = question.isAnswerCorrect();
            style.title.fontColor = isCorrect ? correctColor : incorrectColor;
        }
    });
    surveyPDF.onGetItemStyle.add((_, options) => {
        const question = options.question;
        const item = options.item;
        const style = options.style;
        const correctColor = options.getColorVariable("--sjs2-color-fg-positive-primary");
        const incorrectColor = options.getColorVariable("--sjs2-color-fg-alert-primary");
        const correctCheckMark = "4";
        const incorrectCheckMark = "6";

        if (question.correctAnswer !== undefined && question.correctAnswer !== null) {
            const isItemSelected = question.isItemSelected(item);
            const isItemCorrect = item.value === question.correctAnswer;
            const getColor = () => isItemCorrect ? correctColor : incorrectColor;
            const getCheckMark = () => isItemCorrect ? correctCheckMark : incorrectCheckMark;

            if (isItemSelected) {
                style.choiceText.fontColor = getColor();         
                style.input = style.input || {};
                style.input.fontColor = getColor();
                style.input.borderColor = getColor();
                style.input.checkMark = getCheckMark();
            } else if (isItemCorrect) {
                style.choiceText.fontColor = correctColor;
                style.input.borderColor = correctColor;
            }
            style.input.backgroundColor = options.getColorVariable("--sjs2-color-component-panel-default-bg");
        }
    });

    return surveyPDF;
}
function saveSurveyToPdf (filename, surveyModel) {
    const pdfDoc = createSurveyPdfModel(surveyModel);
    if (!pdfDoc) return;

    pdfDoc.save(filename);
}

const previewDiv = document.getElementById("pdf-preview");
const previewEmbed = document.getElementById("pdf-preview-frame");
let pdfBlobUrl;

function showPdfPreview(surveyModel) {
    if (!previewDiv || !previewEmbed) return;

    const pdfDoc = createSurveyPdfModel(surveyModel);
    if (!pdfDoc) return;

    pdfDoc.raw("blob").then((blob) => {
        if (pdfBlobUrl) {
            URL.revokeObjectURL(pdfBlobUrl);
        }
        pdfBlobUrl = URL.createObjectURL(blob);
        previewEmbed.setAttribute("src", pdfBlobUrl);
        previewDiv.style.display = "block";
    });
}

function previewPdf(surveyModel) {
    if (!previewDiv) return;

    if (previewDiv.style.display !== "none") {
        previewDiv.style.display = "none";
        return;
    }

    showPdfPreview(surveyModel);
}

const survey = new Model(json);
survey.showCompleteButton = false;
survey.navigationButtonsLocation = "topBottom";
survey.addNavigationItem({
    id: "survey_save_as_file",
    title: "Download PDF",
    action: () => {
        saveSurveyToPdf("surveyResult.pdf", survey);
    }
});
survey.addNavigationItem({
    id: "survey_pdf_preview",
    title: "Preview PDF",
    visible: window.navigator.pdfViewerEnabled,
    action: () => {
        previewPdf(survey);
    }
});
survey.data = {
    "username": "John Doe",
    "civilwar": "1861-1865",
    "libertyordeath": "James Madison",
    "magnacarta": "The foundation of the British parliamentary system",
};
survey.render(document.getElementById("surveyElement"));
```

### `src/json.js`

```js
export const json = {
  "title": "American History",
  "description": "You are about to begin a quiz on American history. Enter your name in the field provided, then respond to the questions below.",
  "headerView": "advanced",
  "pages": [
    {
      "elements": [        
        {
          "type": "text",
          "name": "username",
          "title": "Your Name",          
          "isRequired": true,
          "maxLength": 25
        },
        {
          "type": "radiogroup",
          "name": "civilwar",
          "title": "When was the American Civil War?",
          "choices": [
            "1796-1803",
            "1810-1814",
            "1861-1865",
            "1939-1945"
          ],
          "correctAnswer": "1861-1865",
          "isRequired": true
        },
        {
          "type": "radiogroup",
          "name": "libertyordeath",
          "title": "Whose quote is this: \"Give me liberty, or give me death\"?",
          "choicesOrder": "random",
          "choices": [
            "John Hancock",
            "James Madison",
            "Patrick Henry",
            "Samuel Adams"
          ],
          "correctAnswer": "Patrick Henry",
          "isRequired": true
        },
        {
          "type": "radiogroup",
          "name": "magnacarta",
          "title": "What is Magna Carta?",
          "choicesOrder": "random",
          "choices": [
            "The foundation of the British parliamentary system",
            "The Great Seal of the monarchs of England",
            "The French Declaration of the Rights of Man",
            "The charter signed by the Pilgrims on the Mayflower"
          ],
          "correctAnswer": "The foundation of the British parliamentary system",
          "isRequired": true
        }
      ]
    }
  ],
  "completedHtml": "<h4>You got <b>{correctAnswers}</b> out of <b>{questionCount}</b> correct answers.</h4>",
  "completedHtmlOnCondition": [
    {
      "expression": "{correctAnswers} == 0",
      "html": "<h4>Unfortunately, none of your answers is correct. Please try again.</h4>"
    },
    {
      "expression": "{correctAnswers} == {questionCount}",
      "html": "<h4>Congratulations! You answered all the questions correctly!</h4>"
    }
  ]
};
```

### `package.json`

```json
{
  "dependencies": {
    "survey-core": "latest",
    "survey-js-ui": "latest",
    "survey-pdf": "latest"
  }
}
```

## Other Frameworks

- [Angular](https://surveyjs.io/pdf-generator/examples/how-to-customize-question-title-colors-in-pdf-form/angular.md)
- [React](https://surveyjs.io/pdf-generator/examples/how-to-customize-question-title-colors-in-pdf-form/reactjs.md)
- [Vue 3](https://surveyjs.io/pdf-generator/examples/how-to-customize-question-title-colors-in-pdf-form/vue3js.md)
- [jQuery](https://surveyjs.io/pdf-generator/examples/how-to-customize-question-title-colors-in-pdf-form/jquery.md)


---
title: Change Question Title Colors
product: PDF Generator
description: Learn how to add custom visual elements to your question titles in PDF forms. Our free demo for JavaScript will show you how to change the color of question titles to improve their visibility and enhance the overall appearance of your PDF forms.
framework: Angular
source: https://surveyjs.io/pdf-generator/examples/how-to-customize-question-title-colors-in-pdf-form/angular
index: https://surveyjs.io/pdf-generator/examples/overview.md
---

# Change Question Title Colors (Angular)

This demo example shows how to change the color of question titles in a generated PDF form. This feature is especially useful for quiz and test results&mdash;you can visually indicate correctly and incorrectly answered questions using color. To generate a PDF form with applied customizations, answer the quiz questions and click the "Download PDF" or "Preview PDF" button.

## Customize Question Titles

To customize question title colors, handle the [`onGetQuestionStyle`](https://surveyjs.io/pdf-generator/documentation/api-reference/surveypdf#onGetQuestionStyle) event. Within the event handler, use the `options.style` configuration object to obtain and customize styles applied to an individual form field. To apply a custom color to a question title, modify the `options.style.title.fontColor` property. 

You can specify colors directly (for example, using hex values like `"#00ff00"` for green and `"#ff0000"` for red), or obtain them from the current survey theme if you prefer consistency with other styling. To obtain these colors, use the `options.getColorVariable` function.

## Customize Choice Options 

To modify the appearance of a choice's mark and label, handle the [`onGetItemStyle`](https://surveyjs.io/pdf-generator/documentation/api-reference/surveypdf#onGetItemStyle) event. Within the event handler, use the `options.style` configuration object to modify the appearance of a choice item.

Refer to the code listing for more information.

## Files

### `src/app/components/json.ts`

```ts
export const json = {
  "title": "American History",
  "description": "You are about to begin a quiz on American history. Enter your name in the field provided, then respond to the questions below.",
  "headerView": "advanced",
  "pages": [
    {
      "elements": [        
        {
          "type": "text",
          "name": "username",
          "title": "Your Name",          
          "isRequired": true,
          "maxLength": 25
        },
        {
          "type": "radiogroup",
          "name": "civilwar",
          "title": "When was the American Civil War?",
          "choices": [
            "1796-1803",
            "1810-1814",
            "1861-1865",
            "1939-1945"
          ],
          "correctAnswer": "1861-1865",
          "isRequired": true
        },
        {
          "type": "radiogroup",
          "name": "libertyordeath",
          "title": "Whose quote is this: \"Give me liberty, or give me death\"?",
          "choicesOrder": "random",
          "choices": [
            "John Hancock",
            "James Madison",
            "Patrick Henry",
            "Samuel Adams"
          ],
          "correctAnswer": "Patrick Henry",
          "isRequired": true
        },
        {
          "type": "radiogroup",
          "name": "magnacarta",
          "title": "What is Magna Carta?",
          "choicesOrder": "random",
          "choices": [
            "The foundation of the British parliamentary system",
            "The Great Seal of the monarchs of England",
            "The French Declaration of the Rights of Man",
            "The charter signed by the Pilgrims on the Mayflower"
          ],
          "correctAnswer": "The foundation of the British parliamentary system",
          "isRequired": true
        }
      ]
    }
  ],
  "completedHtml": "<h4>You got <b>{correctAnswers}</b> out of <b>{questionCount}</b> correct answers.</h4>",
  "completedHtmlOnCondition": [
    {
      "expression": "{correctAnswers} == 0",
      "html": "<h4>Unfortunately, none of your answers is correct. Please try again.</h4>"
    },
    {
      "expression": "{correctAnswers} == {questionCount}",
      "html": "<h4>Congratulations! You answered all the questions correctly!</h4>"
    }
  ]
};
```

### `src/app/components/pdf.component.css`

```css
/* You can add your custom CSS here. */
```

### `src/app/components/pdf.component.html`

```html
<survey [model]="model"></survey>
```

### `src/app/components/pdf.component.ts`

```ts
import { Component, OnInit } from "@angular/core";
import { Model } from "survey-core";
import { SurveyPDF } from "survey-pdf";
import { json } from "./json";
import "./pdf.component.css";
import "survey-core/survey-core.min.css";

function createSurveyPdfModel (surveyModel) {
    const surveyPDF = new SurveyPDF(json);
    if (surveyModel) {
        surveyPDF.data = surveyModel.data;
        surveyPDF.locale = surveyModel.locale;
        
        
    }
    surveyPDF.readOnly = true;
    surveyPDF.onGetQuestionStyle.add((_, options) => {  
        const question = options.question;
        const style = options.style;
        const correctColor = options.getColorVariable("--sjs2-color-fg-positive-primary");
        const incorrectColor = options.getColorVariable("--sjs2-color-fg-alert-primary");

        if (question.correctAnswer !== undefined && question.correctAnswer !== null) {
            const isCorrect = question.isAnswerCorrect();
            style.title.fontColor = isCorrect ? correctColor : incorrectColor;
        }
    });
    surveyPDF.onGetItemStyle.add((_, options) => {
        const question = options.question;
        const item = options.item;
        const style = options.style;
        const correctColor = options.getColorVariable("--sjs2-color-fg-positive-primary");
        const incorrectColor = options.getColorVariable("--sjs2-color-fg-alert-primary");
        const correctCheckMark = "4";
        const incorrectCheckMark = "6";

        if (question.correctAnswer !== undefined && question.correctAnswer !== null) {
            const isItemSelected = question.isItemSelected(item);
            const isItemCorrect = item.value === question.correctAnswer;
            const getColor = () => isItemCorrect ? correctColor : incorrectColor;
            const getCheckMark = () => isItemCorrect ? correctCheckMark : incorrectCheckMark;

            if (isItemSelected) {
                style.choiceText.fontColor = getColor();         
                style.input = style.input || {};
                style.input.fontColor = getColor();
                style.input.borderColor = getColor();
                style.input.checkMark = getCheckMark();
            } else if (isItemCorrect) {
                style.choiceText.fontColor = correctColor;
                style.input.borderColor = correctColor;
            }
            style.input.backgroundColor = options.getColorVariable("--sjs2-color-component-panel-default-bg");
        }
    });

    return surveyPDF;
}
function saveSurveyToPdf (filename, surveyModel) {
    const pdfDoc = createSurveyPdfModel(surveyModel);
    if (!pdfDoc) return;

    pdfDoc.save(filename);
}

const previewDiv = document.getElementById("pdf-preview");
const previewEmbed = document.getElementById("pdf-preview-frame");
let pdfBlobUrl;

function showPdfPreview(surveyModel) {
    if (!previewDiv || !previewEmbed) return;

    const pdfDoc = createSurveyPdfModel(surveyModel);
    if (!pdfDoc) return;

    pdfDoc.raw("blob").then((blob) => {
        if (pdfBlobUrl) {
            URL.revokeObjectURL(pdfBlobUrl);
        }
        pdfBlobUrl = URL.createObjectURL(blob);
        previewEmbed.setAttribute("src", pdfBlobUrl);
        previewDiv.style.display = "block";
    });
}

function previewPdf(surveyModel) {
    if (!previewDiv) return;

    if (previewDiv.style.display !== "none") {
        previewDiv.style.display = "none";
        return;
    }

    showPdfPreview(surveyModel);
}

@Component({
    // tslint:disable-next-line:component-selector
    selector: "component-survey",
    templateUrl: "./pdf.component.html",
    styleUrls: ["./pdf.component.css"]
})
export class SurveyPdfComponent implements OnInit {
    model: Model;
    ngOnInit() {
        const survey = new Model(json);
        survey.showCompleteButton = false;
        survey.navigationButtonsLocation = "topBottom";
        survey.addNavigationItem({
            id: "survey_save_as_file",
            title: "Download PDF",
            action: () => {
                saveSurveyToPdf("surveyResult.pdf", survey);
            }
        });
        survey.addNavigationItem({
            id: "survey_pdf_preview",
            title: "Preview PDF",
            visible: window.navigator.pdfViewerEnabled,
            action: () => {
                previewPdf(survey);
            }
        });
        survey.data = {
            "username": "John Doe",
            "civilwar": "1861-1865",
            "libertyordeath": "James Madison",
            "magnacarta": "The foundation of the British parliamentary system",
        };
        this.model = survey;
    }
}
```

### `src/app/app.component.css`

```css

```

### `src/app/app.component.html`

```html
<component-survey></component-survey>
```

### `src/app/app.component.ts`

```ts
import { Component } from "@angular/core";

@Component({
    selector: "app-root",
    templateUrl: "./app.component.html",
    styleUrls: ["./app.component.css"]
})
export class AppComponent {
    title = "CodeSandbox";
}
```

### `src/app/app.module.ts`

```ts
import { BrowserModule } from "@angular/platform-browser";
import { NgModule } from "@angular/core";

import { AppComponent } from "./app.component";
import { SurveyModule } from "survey-angular-ui";
import { SurveyPdfComponent } from "./components/pdf.component";

@NgModule({
    declarations: [AppComponent, SurveyPdfComponent],
    imports: [BrowserModule, SurveyModule],
    providers: [],
    bootstrap: [AppComponent]
})
export class AppModule { }
```

### `src/environments/environment.prod.ts`

```ts
export const environment = {
    production: true
};
```

### `src/environments/environment.ts`

```ts
// The file contents for the current environment will overwrite these during build.
// The build system defaults to the dev environment which uses `environment.ts`, but if you do
// `ng build --env=prod` then `environment.prod.ts` will be used instead.
// The list of which env maps to which file can be found in `.angular-cli.json`.

export const environment = {
    production: false
};
```

### `src/index.html`

```html
<div style="display: flex;">
    <div id="surveyElement" style="flex: 1 1 0%; height: 100%; min-width: 0;">
        <app-root></app-root>
    </div>
    <div id="pdf-preview" style="flex: 0.7 0.7 0%; display: none">
        <embed id="pdf-preview-frame" type="application/pdf" style="width:100%; height:100%;" />
    </div>
</div>
```

### `src/main.ts`

```ts
import { enableProdMode } from "@angular/core";
import { platformBrowserDynamic } from "@angular/platform-browser-dynamic";

import { AppModule } from "./app/app.module";
import { environment } from "./environments/environment";

if (environment.production) {
    enableProdMode();
}

platformBrowserDynamic()
    .bootstrapModule(AppModule)
    .catch(err => console.log(err));
```

### `src/polyfills.ts`

```ts
/**
 * This file includes polyfills needed by Angular and is loaded before the app.
 * You can add your own extra polyfills to this file.
 *
 * This file is divided into 2 sections:
 *   1. Browser polyfills. These are applied before loading ZoneJS and are sorted by browsers.
 *   2. Application imports. Files imported after ZoneJS that should be loaded before your main
 *      file.
 *
 * The current setup is for so-called "evergreen" browsers; the last versions of browsers that
 * automatically update themselves. This includes Safari >= 10, Chrome >= 55 (including Opera),
 * Edge >= 13 on the desktop, and iOS 10 and Chrome on mobile.
 *
 * Learn more in https://angular.io/docs/ts/latest/guide/browser-support.html
 */

/***************************************************************************************************
 * BROWSER POLYFILLS
 */

/** IE9, IE10 and IE11 requires all of the following polyfills. **/
// import 'core-js/es6/symbol';
// import 'core-js/es6/object';
// import 'core-js/es6/function';
// import 'core-js/es6/parse-int';
// import 'core-js/es6/parse-float';
// import 'core-js/es6/number';
// import 'core-js/es6/math';
// import 'core-js/es6/string';
// import 'core-js/es6/date';
// import 'core-js/es6/array';
// import 'core-js/es6/regexp';
// import 'core-js/es6/map';
// import 'core-js/es6/weak-map';
// import 'core-js/es6/set';

/** IE10 and IE11 requires the following for NgClass support on SVG elements */
// import 'classlist.js';  // Run `npm install classlist.js`.

/** IE10 and IE11 requires the following for the Reflect API. */
// import 'core-js/es6/reflect';

/** Evergreen browsers require these. **/
// Used for reflect-metadata in JIT. If you use AOT (and only Angular decorators), you can remove.
import "core-js/proposals/reflect-metadata";

/**
 * Required to support Web Animations `@angular/platform-browser/animations`.
 * Needed for: All but Chrome, Firefox and Opera. http://caniuse.com/#feat=web-animation
 **/
// import 'web-animations-js';  // Run `npm install web-animations-js`.

/***************************************************************************************************
 * Zone JS is required by default for Angular itself.
 */
import "zone.js/dist/zone"; // Included with Angular CLI.

/***************************************************************************************************
 * APPLICATION IMPORTS
 */
```

### `src/styles.css`

```css

```

### `src/typings.d.ts`

```ts
/* SystemJS module definition */
declare var module: NodeModule;
interface NodeModule {
    id: string;
}
```

### `.angular-cli.json`

```json
{
  "apps": [
    {
      "root": "src",
      "outDir": "dist",
      "assets": [ "assets", "favicon.ico" ],
      "index": "index.html",
      "main": "main.ts",
      "polyfills": "polyfills.ts",
      "prefix": "app",
      "styles": [ "styles.css" ],
      "scripts": [ ],
      "environmentSource": "environments/environment.ts",
      "environments": {
        "dev": "environments/environment.ts",
        "prod": "environments/environment.prod.ts"
      }
    }
  ]
}
```

### `_tsconfig.json`

```json
{
  "compileOnSave": false,
  "compilerOptions": {
    "baseUrl": "./",
    "outDir": "./dist/out-tsc",
    "sourceMap": true,
    "declaration": false,
    "allowSyntheticDefaultImports": true,
    "downlevelIteration": true,
    "experimentalDecorators": true,
    "moduleResolution": "node",
    "importHelpers": true,
    "resolveJsonModule": true,
    "target": "es2015",
    "module": "es2020",
    "lib": [
      "es2018",
      "dom"
    ]
  }
}
```

### `package.json`

```json
{
  "name": "surveyjs-angular",
  "scripts": {
    "ng": "ng",
    "start": "ng serve",
    "build": "ng build --prod",
    "test": "ng test",
    "lint": "ng lint",
    "e2e": "ng e2e"
  },
  "private": true,
  "dependencies": {
    "@angular/animations": "14.1.1",
    "@angular/cdk": "14.1.1",
    "@angular/common": "14.1.1",
    "@angular/compiler": "14.1.1",
    "@angular/core": "14.1.1",
    "@angular/forms": "14.1.1",
    "@angular/platform-browser": "14.1.1",
    "@angular/platform-browser-dynamic": "14.1.1",
    "@angular/router": "14.1.1",
    "core-js": "3.6.4",
    "rxjs": "6.5.4",
    "survey-core": "latest",
    "survey-angular-ui": "latest",
    "survey-pdf": "latest",
    "tslib": "1.13.0",
    "zone.js": "0.11.7"
  },
  "devDependencies": {
    "@angular/cli": "1.6.6",
    "@angular/compiler-cli": "^5.2.0",
    "@angular/language-service": "^5.2.0",
    "@types/core-js": "0.9.46",
    "@types/jasmine": "~2.8.3",
    "@types/jasminewd2": "~2.0.2",
    "@types/node": "~6.0.60",
    "codelyzer": "^4.0.1",
    "jasmine-core": "~2.8.0",
    "jasmine-spec-reporter": "~4.2.1",
    "karma": "~2.0.0",
    "karma-chrome-launcher": "~2.2.0",
    "karma-coverage-istanbul-reporter": "^1.2.1",
    "karma-jasmine": "~1.1.0",
    "karma-jasmine-html-reporter": "^0.2.2",
    "protractor": "~5.1.2",
    "ts-node": "~4.1.0",
    "tslint": "~5.9.1",
    "typescript": "3.9.7"
  },
  "keywords": [ "angular", "surveyjs" ],
  "description": "SurveyJS-Angular example project"
}
```

## Other Frameworks

- [React](https://surveyjs.io/pdf-generator/examples/how-to-customize-question-title-colors-in-pdf-form/reactjs.md)
- [Vue 3](https://surveyjs.io/pdf-generator/examples/how-to-customize-question-title-colors-in-pdf-form/vue3js.md)
- [jQuery](https://surveyjs.io/pdf-generator/examples/how-to-customize-question-title-colors-in-pdf-form/jquery.md)
- [Vanilla JS](https://surveyjs.io/pdf-generator/examples/how-to-customize-question-title-colors-in-pdf-form/vanillajs.md)


---
title: Change Question Title Colors
product: PDF Generator
description: Learn how to add custom visual elements to your question titles in PDF forms. Our free demo for JavaScript will show you how to change the color of question titles to improve their visibility and enhance the overall appearance of your PDF forms.
framework: React
source: https://surveyjs.io/pdf-generator/examples/how-to-customize-question-title-colors-in-pdf-form/reactjs
index: https://surveyjs.io/pdf-generator/examples/overview.md
---

# Change Question Title Colors (React)

This demo example shows how to change the color of question titles in a generated PDF form. This feature is especially useful for quiz and test results&mdash;you can visually indicate correctly and incorrectly answered questions using color. To generate a PDF form with applied customizations, answer the quiz questions and click the "Download PDF" or "Preview PDF" button.

## Customize Question Titles

To customize question title colors, handle the [`onGetQuestionStyle`](https://surveyjs.io/pdf-generator/documentation/api-reference/surveypdf#onGetQuestionStyle) event. Within the event handler, use the `options.style` configuration object to obtain and customize styles applied to an individual form field. To apply a custom color to a question title, modify the `options.style.title.fontColor` property. 

You can specify colors directly (for example, using hex values like `"#00ff00"` for green and `"#ff0000"` for red), or obtain them from the current survey theme if you prefer consistency with other styling. To obtain these colors, use the `options.getColorVariable` function.

## Customize Choice Options 

To modify the appearance of a choice's mark and label, handle the [`onGetItemStyle`](https://surveyjs.io/pdf-generator/documentation/api-reference/surveypdf#onGetItemStyle) event. Within the event handler, use the `options.style` configuration object to modify the appearance of a choice item.

Refer to the code listing for more information.

## Files

### `public/index.html`

```html
<div style="display: flex;">
    <div id="surveyElement" style="flex: 1 1 0%; height: 100%; min-width: 0;"></div>
    <div id="pdf-preview" style="flex: 0.7 0.7 0%; display: none">
        <embed id="pdf-preview-frame" type="application/pdf" style="width:100%; height:100%;" />
    </div>
</div>
```

### `src/SurveyPdfComponent.jsx`

```js
import React from "react";
import { Model } from "survey-core";
import { SurveyPDF } from "survey-pdf";
import { Survey } from "survey-react-ui";
import "survey-core/survey-core.min.css";
import "./index.css";
import { json } from "./json";

function createSurveyPdfModel (surveyModel) {
    const surveyPDF = new SurveyPDF(json);
    if (surveyModel) {
        surveyPDF.data = surveyModel.data;
        surveyPDF.locale = surveyModel.locale;
        
        
    }
    surveyPDF.readOnly = true;
    surveyPDF.onGetQuestionStyle.add((_, options) => {  
        const question = options.question;
        const style = options.style;
        const correctColor = options.getColorVariable("--sjs2-color-fg-positive-primary");
        const incorrectColor = options.getColorVariable("--sjs2-color-fg-alert-primary");

        if (question.correctAnswer !== undefined && question.correctAnswer !== null) {
            const isCorrect = question.isAnswerCorrect();
            style.title.fontColor = isCorrect ? correctColor : incorrectColor;
        }
    });
    surveyPDF.onGetItemStyle.add((_, options) => {
        const question = options.question;
        const item = options.item;
        const style = options.style;
        const correctColor = options.getColorVariable("--sjs2-color-fg-positive-primary");
        const incorrectColor = options.getColorVariable("--sjs2-color-fg-alert-primary");
        const correctCheckMark = "4";
        const incorrectCheckMark = "6";

        if (question.correctAnswer !== undefined && question.correctAnswer !== null) {
            const isItemSelected = question.isItemSelected(item);
            const isItemCorrect = item.value === question.correctAnswer;
            const getColor = () => isItemCorrect ? correctColor : incorrectColor;
            const getCheckMark = () => isItemCorrect ? correctCheckMark : incorrectCheckMark;

            if (isItemSelected) {
                style.choiceText.fontColor = getColor();         
                style.input = style.input || {};
                style.input.fontColor = getColor();
                style.input.borderColor = getColor();
                style.input.checkMark = getCheckMark();
            } else if (isItemCorrect) {
                style.choiceText.fontColor = correctColor;
                style.input.borderColor = correctColor;
            }
            style.input.backgroundColor = options.getColorVariable("--sjs2-color-component-panel-default-bg");
        }
    });

    return surveyPDF;
}
function saveSurveyToPdf (filename, surveyModel) {
    const pdfDoc = createSurveyPdfModel(surveyModel);
    if (!pdfDoc) return;

    pdfDoc.save(filename);
}

const previewDiv = document.getElementById("pdf-preview");
const previewEmbed = document.getElementById("pdf-preview-frame");
let pdfBlobUrl;

function showPdfPreview(surveyModel) {
    if (!previewDiv || !previewEmbed) return;

    const pdfDoc = createSurveyPdfModel(surveyModel);
    if (!pdfDoc) return;

    pdfDoc.raw("blob").then((blob) => {
        if (pdfBlobUrl) {
            URL.revokeObjectURL(pdfBlobUrl);
        }
        pdfBlobUrl = URL.createObjectURL(blob);
        previewEmbed.setAttribute("src", pdfBlobUrl);
        previewDiv.style.display = "block";
    });
}

function previewPdf(surveyModel) {
    if (!previewDiv) return;

    if (previewDiv.style.display !== "none") {
        previewDiv.style.display = "none";
        return;
    }

    showPdfPreview(surveyModel);
}

function SurveyPdfComponent () {
    const survey = new Model(json);
    survey.showCompleteButton = false;
    survey.navigationButtonsLocation = "topBottom";
    survey.addNavigationItem({
        id: "survey_save_as_file",
        title: "Download PDF",
        action: () => {
            saveSurveyToPdf("surveyResult.pdf", survey);
        }
    });
    survey.addNavigationItem({
        id: "survey_pdf_preview",
        title: "Preview PDF",
        visible: window.navigator.pdfViewerEnabled,
        action: () => {
            previewPdf(survey);
        }
    });
    survey.data = {
        "username": "John Doe",
        "civilwar": "1861-1865",
        "libertyordeath": "James Madison",
        "magnacarta": "The foundation of the British parliamentary system",
    };
    return (<Survey model={survey} />);
}

export default SurveyPdfComponent;
```

### `src/index.css`

```css
/* You can add your custom CSS here. */
```

### `src/index.js`

```js
import React from "react";
import { createRoot } from "react-dom/client";
import SurveyPdfComponent from "./SurveyPdfComponent";

const root = createRoot(document.getElementById("surveyElement"));
root.render(<SurveyPdfComponent />);
```

### `src/json.js`

```js
export const json = {
  "title": "American History",
  "description": "You are about to begin a quiz on American history. Enter your name in the field provided, then respond to the questions below.",
  "headerView": "advanced",
  "pages": [
    {
      "elements": [        
        {
          "type": "text",
          "name": "username",
          "title": "Your Name",          
          "isRequired": true,
          "maxLength": 25
        },
        {
          "type": "radiogroup",
          "name": "civilwar",
          "title": "When was the American Civil War?",
          "choices": [
            "1796-1803",
            "1810-1814",
            "1861-1865",
            "1939-1945"
          ],
          "correctAnswer": "1861-1865",
          "isRequired": true
        },
        {
          "type": "radiogroup",
          "name": "libertyordeath",
          "title": "Whose quote is this: \"Give me liberty, or give me death\"?",
          "choicesOrder": "random",
          "choices": [
            "John Hancock",
            "James Madison",
            "Patrick Henry",
            "Samuel Adams"
          ],
          "correctAnswer": "Patrick Henry",
          "isRequired": true
        },
        {
          "type": "radiogroup",
          "name": "magnacarta",
          "title": "What is Magna Carta?",
          "choicesOrder": "random",
          "choices": [
            "The foundation of the British parliamentary system",
            "The Great Seal of the monarchs of England",
            "The French Declaration of the Rights of Man",
            "The charter signed by the Pilgrims on the Mayflower"
          ],
          "correctAnswer": "The foundation of the British parliamentary system",
          "isRequired": true
        }
      ]
    }
  ],
  "completedHtml": "<h4>You got <b>{correctAnswers}</b> out of <b>{questionCount}</b> correct answers.</h4>",
  "completedHtmlOnCondition": [
    {
      "expression": "{correctAnswers} == 0",
      "html": "<h4>Unfortunately, none of your answers is correct. Please try again.</h4>"
    },
    {
      "expression": "{correctAnswers} == {questionCount}",
      "html": "<h4>Congratulations! You answered all the questions correctly!</h4>"
    }
  ]
};
```

### `package.json`

```json
{
  "dependencies": {
    "react": "latest",
    "react-dom": "latest",
    "survey-core": "latest",
    "survey-react-ui": "latest",
    "survey-pdf": "latest"
  },
  "devDependencies": {
    "react-scripts": "latest"
  }
}
```

## Other Frameworks

- [Angular](https://surveyjs.io/pdf-generator/examples/how-to-customize-question-title-colors-in-pdf-form/angular.md)
- [Vue 3](https://surveyjs.io/pdf-generator/examples/how-to-customize-question-title-colors-in-pdf-form/vue3js.md)
- [jQuery](https://surveyjs.io/pdf-generator/examples/how-to-customize-question-title-colors-in-pdf-form/jquery.md)
- [Vanilla JS](https://surveyjs.io/pdf-generator/examples/how-to-customize-question-title-colors-in-pdf-form/vanillajs.md)
